#include <string.h>
#include <stdlib.h>
#include <fstream>
#include <iostream>
#include "myheader.h"
#include <GL/glui.h>

double theta(double x, double y);

void rotate_atom(float x, float y, float z)
{
  double center_x = cell.hmat[0][0]/2.0;
  double center_y = cell.hmat[1][1]/2.0;
  double center_z = cell.hmat[2][2]/2.0;
  double xx, yy, zz, rr, t, tt;
  for (int i=1; i<=atom.natom; i++) {
    xx = atom.rx[i] - center_x;
    yy = atom.ry[i] - center_y;
    rr = sqrt(xx*xx+yy*yy);
    t  = theta(xx,yy);
    tt = t + (double)z /180.0 * M_PI;
    atom.rx[i] = center_x + rr * cos(tt);
    atom.ry[i] = center_y + rr * sin(tt);
  }
  for (int i=1; i<=atom.natom; i++) {
    yy = atom.ry[i] - center_y;
    zz = atom.rz[i] - center_z;
    rr = sqrt(yy*yy+zz*zz);
    t  = theta(yy,zz);
    tt = t + (double)x /180.0 * M_PI;
    atom.ry[i] = center_y + rr * cos(tt);
    atom.rz[i] = center_z + rr * sin(tt);
  }
  for (int i=1; i<=atom.natom; i++) {
    zz = atom.rz[i] - center_z;
    xx = atom.rx[i] - center_x;
    rr = sqrt(zz*zz+xx*xx);
    t  = theta(zz,xx);
    tt = t + (double)y /180.0 * M_PI;
    atom.rz[i] = center_z + rr * cos(tt);
    atom.rx[i] = center_x + rr * sin(tt);
  }
}
